//  bibNumber,title,topic,pops,pages,rating,checkoutAverage,checkoutVariance
class Bib implements Comparable<Bib> {

  FloatDict data;
  String title;
  
  BucketGrid masterGrid;
  
  Bib( TableRow newRow, BucketGrid g ) {
    masterGrid = g;
    data = new FloatDict();
    for ( int i = 0; i < masterGrid.attributes.length; i++ ) {
      data.set( masterGrid.attributes[ i ], newRow.getFloat( masterGrid.attributes[ i ] ) );
    }
    title = newRow.getString( "title" );
    data.set( "controversy", 0  );
  }
  
  void validateControversy() {
    float cont =  0.4 * this.data.get( "pops" ) / masterGrid.maxs.get( "pops" ) + 
                  0.6 * this.data.get( "checkoutVariance" ) / masterGrid.maxs.get( "checkoutVariance" );
                  /*0.3 * min( 1.0, max( 0.0, abs( 3.56 - ( this.data.get( "pages" ) / this.data.get( "checkoutAverage" ) / (60*60*24) ) ) / 3.56 ) ); +
                  0.2 * min( 1.0, max( 0.0, ( abs( 2.5 - this.data.get( "rating" ) ) / 2.5 ) ) );*/
    data.set( "controversy", cont  );

  }
  
  public int compareTo( Bib otherBib ) {
   return (int) floor( otherBib.data.get( "controversy" ) - this.data.get( "controversy" ) ); 
  }
  
}
